package diffusioncalculator;

import java.util.ArrayList;

import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

public class CurrentChartModel {

	// Declaring lists and variables
	XYSeriesCollection dataset;
	public ArrayList<Float> time;
	public ArrayList<Float> current;
	XYSeries series;
	double scaleCurrent;
	float temp;

	// Constructor initializing the data set
	public CurrentChartModel(ArrayList<Float> inputTime,
			ArrayList<Float> inputCurrent) {
		time = inputTime;
		current = inputCurrent;
		series = new XYSeries("Current/Time Curve");

		// Adding x and y values to the series
		for (int i = 0; i < time.size(); i++) {
			scaleCurrent = current.get(i) * 1000000;
			series.add((double) (time.get(i)), scaleCurrent);
		}

		// Adding the series to the data set
		dataset = new XYSeriesCollection();
		dataset.addSeries(series);
	}

	// Implementing the low pass filter method
	public void lowPassFilter() {
		float lastValue = 0f;
		float lastlastValue = 0f;
		int counter = 0;
		double db;
		// Looking for abnormal values and replacing them
		for (int i = 0; i < time.size(); i++) {
			db = (double) (series.getY(i));
			temp = (float) db;
			if (temp - lastValue > 0.02962) {
				series.remove(i);
				series.add(series.getX(i - 1), (double) (lastValue));
			} else if (temp - lastlastValue > 0.04) {
				series.remove(i);
				series.add(series.getX(i - 1), (double) (lastValue));
			} else {
				lastValue = temp;
				counter++;
			}
			if (counter == 2) {
				lastlastValue = lastValue;
				counter = 0;
			}

		}
	}

	// Implementing the high pass filter method
	public void highPassFilter() {
		float lastValue = 0f;
		float lastlastValue = 0f;
		int counter = 0;
		double db;
		// Looking for abnormal values and replacing them
		for (int i = 0; i < time.size(); i++) {
			db = (double) (series.getY(i));
			temp = (float) db;
			if (temp - lastValue < 0.02962) {
				series.remove(i);
				series.add(series.getX(i - 1), (double) (lastValue));
			} else if (temp - lastlastValue < 0.04) {
				series.remove(i);
				series.add(series.getX(i - 1), (double) (lastValue));
			} else {
				lastValue = temp;
				counter++;
			}
			if (counter == 2) {
				lastlastValue = lastValue;
				counter = 0;
			}

		}
	}

	// Restoring the original plot
	public void restore() {
		series.clear();
		for (int i = 0; i < time.size(); i++) {
			scaleCurrent = current.get(i) * 1000000;
			series.add((double) (time.get(i)), scaleCurrent);
		}
	}
}
