package diffusioncalculator;

import java.util.ArrayList;

import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

public class PermeationChartModel {

	// Declaring lists and variables
	XYSeriesCollection dataset;
	public ArrayList<Float> tau;
	public ArrayList<Float> flux;
	XYSeries series;
	float temp;

	// Constructor initializing the data set
	public PermeationChartModel(ArrayList<Float> inputTau,
			ArrayList<Float> inputFlux) {
		tau = inputTau;
		flux = inputFlux;
		series = new XYSeries("Permation Current Curve");

		// Adding x and y values to the series
		for (int i = 0; i < tau.size(); i++) {
			series.add(tau.get(i), flux.get(i));
		}

		// Adding the series to the data set
		dataset = new XYSeriesCollection();
		dataset.addSeries(series);
	}

	// Implementing the low pass filter method
	public void lowPassFilter() {
		float lastValue = 0f;
		float lastlastValue = 0f;
		int counter = 0;
		// Looking for abnormal values and replacing them
		for (int i = 0; i < tau.size(); i++) {
			temp = (float) (series.getY(i));
			if (temp - lastValue > 0.02962) {
				series.remove(i);
				series.add(series.getX(i - 1), (double) (lastValue));
			} else if (temp - lastlastValue > 0.04) {
				series.remove(i);
				series.add(series.getX(i - 1), (double) (lastValue));
			} else {
				lastValue = temp;
				counter++;
			}
			if (counter == 2) {
				lastlastValue = lastValue;
				counter = 0;
			}

		}
	}

	// Implementing the high pass filter method
	public void highPassFilter() {
		float lastValue = 0f;
		float lastlastValue = 0f;
		int counter = 0;
		// Looking for abnormal values and replacing them
		for (int i = 0; i < tau.size(); i++) {
			temp = (float) (series.getY(i));
			if (temp - lastValue < 0.02962) {
				series.remove(i);
				series.add(series.getX(i - 1), (double) (lastValue));
			} else if (temp - lastlastValue < 0.04) {
				series.remove(i);
				series.add(series.getX(i - 1), (double) (lastValue));
			} else {
				lastValue = temp;
				counter++;
			}
			if (counter == 2) {
				lastlastValue = lastValue;
				counter = 0;
			}

		}
	}

	// Restoring the original plot
	public void restore() {
		series.clear();
		for (int i = 0; i < tau.size(); i++) {
			series.add(tau.get(i), flux.get(i));
		}
	}

}
