package diffusioncalculator;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import javax.swing.JFileChooser;

public class ReadView {

	// Declare reading variables
	JFileChooser fc;
	String line;
	ReadModel readmodel;
	int counter;
	FileReader fr;
	File file;
	StartEndPoint startPoint;
	StartEndPoint endPoint;
	int start;
	int end;

	// Make instances and display file chooser
	public ReadView(ReadModel modelInput) throws IOException {
		readmodel = modelInput;
		fc = new JFileChooser(System.getProperty("user.home") + File.separator
				+ "Desktop" + File.separator);

		// Select file to read from
		if (fc.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
			file = fc.getSelectedFile();
			fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			counter = 0;
			
			startPoint = new StartEndPoint("start", fc);
			endPoint = new StartEndPoint("end", fc);
			
			start = Integer.parseInt(startPoint.input);
			end = Integer.parseInt(endPoint.input);
			
			// Subtract to get correct readings
			if (start > 0){
				start -= 3;
			}
			
			// Skipping the first 56 lines + lines until start
			while (counter != (56 + start/3)) {
				br.readLine();
				counter++;
			}
			
			counter = 0;
			// Reading values to arrays
			while ((line = br.readLine()) != null) {
				if (counter < end/3){
					readmodel.read(line, start);
				}
				counter++;
			}
			br.close();
		}

		// Display error message if no file gets selected
		else {
			readmodel.values[0] = ("No file was selected");
		}
	}
}