package diffusioncalculator;

import java.io.IOException;


/* Main class representing the controller.
 * Letting the user select a file to read 
 * into the program, and creates the result
 * frame, currently containing all other 
 * properties of the program */
public class DiffusionCalculator {

	public static void main(String[] args) throws IOException {
      
		// Making an instance of the ReadModel class, containing functions
		// used by the ReadView class to make GUI.
		// Used to read and save data
		ReadModel readModel = new ReadModel();
		new ReadView(readModel);
		
		// Making an instance the ResultsModel class, taking ArrayLists and filename from the
		// file reading as arguments. ResultsView uses data generated in this class,
		// to make GUI offering further aspects of the program
		ResultsModel resultsModel = new ResultsModel(readModel.time, readModel.current, readModel.name);
		new ResultsView(resultsModel);
   }
   
}