package diffusioncalculator;

import java.util.ArrayList;

/* Doing all the reading and parsing
 * from the file chosen through the
 * ReadView class. */
public class ReadModel {

	// Declaring variable to hold name of file read
	private String name;

	// Declaring lists to hold relevant data read from the file
	private ArrayList<Float> time;
	private ArrayList<Float> current;

	// Declaring a string array for each line
	private String[] values;

	// Make constructor which initializes ArrayLists
	public ReadModel() {
		time = new ArrayList<Float>();
		current = new ArrayList<Float>();
	}

	// Assign values to lists
	public void read(String line, int startTime) {
		// Retrieve an array of the values from line that are separated by tab
		values = line.split("\t");

		// Add time values to the list
		time.add(Float.parseFloat(values[2]) - startTime);

		// Replace commas with dots to make parsing possible
		String temp = values[4].replaceAll(",", ".");

		// Try to add float to the list, or add 0 if value is unreadable
		try {
			current.add(Float.parseFloat(temp));
		}

		// Handle exception
		catch (NumberFormatException ex) {
			current.add(Float.parseFloat("0"));
		}
	}

	// Set the name field to new value
	public void setName(String newName) {
		name = newName;
	}

	// Get the name field
	public String getName() {
		return name;
	}

	// Get the time field
	public ArrayList<Float> getTime() {
		return time;
	}

	// Get the current field
	public ArrayList<Float> getCurrent() {
		return current;
	}
	
	// Set first value of array
	public void setValues(String newValue){
		values[0] = newValue;
	}
}
